import _pt from "prop-types";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import * as React from 'react';
import { css } from '@patternfly/react-styles';
import styles from '@patternfly/react-styles/css/components/ChipGroup/chip-group';
import { ChipGroupContext } from './ChipGroup';
import { ChipButton } from './ChipButton';
import TimesIcon from "@patternfly/react-icons/dist/esm/icons/times-icon";
import GenerateId from '../../helpers/GenerateId/GenerateId';
export const ChipGroupToolbarItem = (_ref) => {
  let {
    categoryName = '',
    children = null,
    className = '',
    isClosable = false,
    onClick = _e => undefined,
    closeBtnAriaLabel = 'Close chip group'
  } = _ref,
      props = _objectWithoutProperties(_ref, ["categoryName", "children", "className", "isClosable", "onClick", "closeBtnAriaLabel"]);

  if (React.Children.count(children)) {
    const renderChipGroup = (id, HeadingLevel) => {
      return React.createElement("ul", _extends({
        className: css(styles.chipGroup, styles.modifiers.toolbar, className)
      }, props), React.createElement("li", null, React.createElement(HeadingLevel, {
        className: css(styles.chipGroupLabel),
        id: id
      }, categoryName), React.createElement("ul", {
        className: css(styles.chipGroup)
      }, children), isClosable && React.createElement("div", {
        className: "pf-c-chip-group__close"
      }, React.createElement(ChipButton, {
        "aria-label": closeBtnAriaLabel,
        onClick: onClick,
        id: `remove_group_${id}`,
        "aria-labelledby": `remove_group_${id} ${id}`
      }, React.createElement(TimesIcon, {
        "aria-hidden": "true"
      })))));
    };

    return React.createElement(ChipGroupContext.Consumer, null, HeadingLevel => {
      return React.createElement(GenerateId, null, randomId => renderChipGroup(randomId, HeadingLevel));
    });
  }

  return null;
};
ChipGroupToolbarItem.propTypes = {
  categoryName: _pt.string,
  children: _pt.node.isRequired,
  className: _pt.string,
  isClosable: _pt.bool,
  onClick: _pt.func,
  closeBtnAriaLabel: _pt.string
};
//# sourceMappingURL=ChipGroupToolbarItem.js.map