"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ChipGroupToolbarItem = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var React = _interopRequireWildcard(require("react"));

var _reactStyles = require("@patternfly/react-styles");

var _chipGroup = _interopRequireDefault(require("@patternfly/react-styles/css/components/ChipGroup/chip-group"));

var _ChipGroup = require("./ChipGroup");

var _ChipButton = require("./ChipButton");

var _timesIcon = _interopRequireDefault(require("@patternfly/react-icons/dist/js/icons/times-icon"));

var _GenerateId = _interopRequireDefault(require("../../helpers/GenerateId/GenerateId"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ChipGroupToolbarItem = function ChipGroupToolbarItem(_ref) {
  var _ref$categoryName = _ref.categoryName,
      categoryName = _ref$categoryName === void 0 ? '' : _ref$categoryName,
      _ref$children = _ref.children,
      children = _ref$children === void 0 ? null : _ref$children,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className,
      _ref$isClosable = _ref.isClosable,
      isClosable = _ref$isClosable === void 0 ? false : _ref$isClosable,
      _ref$onClick = _ref.onClick,
      onClick = _ref$onClick === void 0 ? function (_e) {
    return undefined;
  } : _ref$onClick,
      _ref$closeBtnAriaLabe = _ref.closeBtnAriaLabel,
      closeBtnAriaLabel = _ref$closeBtnAriaLabe === void 0 ? 'Close chip group' : _ref$closeBtnAriaLabe,
      props = _objectWithoutProperties(_ref, ["categoryName", "children", "className", "isClosable", "onClick", "closeBtnAriaLabel"]);

  if (React.Children.count(children)) {
    var renderChipGroup = function renderChipGroup(id, HeadingLevel) {
      return React.createElement("ul", _extends({
        className: (0, _reactStyles.css)(_chipGroup["default"].chipGroup, _chipGroup["default"].modifiers.toolbar, className)
      }, props), React.createElement("li", null, React.createElement(HeadingLevel, {
        className: (0, _reactStyles.css)(_chipGroup["default"].chipGroupLabel),
        id: id
      }, categoryName), React.createElement("ul", {
        className: (0, _reactStyles.css)(_chipGroup["default"].chipGroup)
      }, children), isClosable && React.createElement("div", {
        className: "pf-c-chip-group__close"
      }, React.createElement(_ChipButton.ChipButton, {
        "aria-label": closeBtnAriaLabel,
        onClick: onClick,
        id: "remove_group_".concat(id),
        "aria-labelledby": "remove_group_".concat(id, " ").concat(id)
      }, React.createElement(_timesIcon["default"], {
        "aria-hidden": "true"
      })))));
    };

    return React.createElement(_ChipGroup.ChipGroupContext.Consumer, null, function (HeadingLevel) {
      return React.createElement(_GenerateId["default"], null, function (randomId) {
        return renderChipGroup(randomId, HeadingLevel);
      });
    });
  }

  return null;
};

exports.ChipGroupToolbarItem = ChipGroupToolbarItem;
ChipGroupToolbarItem.propTypes = {
  categoryName: _propTypes["default"].string,
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string,
  isClosable: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  closeBtnAriaLabel: _propTypes["default"].string
};
//# sourceMappingURL=ChipGroupToolbarItem.js.map