(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(["exports", "prop-types", "react", "@patternfly/react-styles", "@patternfly/react-styles/css/components/ChipGroup/chip-group", "./ChipGroup", "./ChipButton", "@patternfly/react-icons/dist/esm/icons/times-icon", "../../helpers/GenerateId/GenerateId"], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require("prop-types"), require("react"), require("@patternfly/react-styles"), require("@patternfly/react-styles/css/components/ChipGroup/chip-group"), require("./ChipGroup"), require("./ChipButton"), require("@patternfly/react-icons/dist/esm/icons/times-icon"), require("../../helpers/GenerateId/GenerateId"));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.propTypes, global.react, global.reactStyles, global.chipGroup, global.ChipGroup, global.ChipButton, global.timesIcon, global.GenerateId);
    global.undefined = mod.exports;
  }
})(this, function (exports, _propTypes, _react, _reactStyles, _chipGroup, _ChipGroup, _ChipButton, _timesIcon, _GenerateId) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.ChipGroupToolbarItem = undefined;

  var _propTypes2 = _interopRequireDefault(_propTypes);

  var React = _interopRequireWildcard(_react);

  var _chipGroup2 = _interopRequireDefault(_chipGroup);

  var _timesIcon2 = _interopRequireDefault(_timesIcon);

  var _GenerateId2 = _interopRequireDefault(_GenerateId);

  function _getRequireWildcardCache() {
    if (typeof WeakMap !== "function") return null;
    var cache = new WeakMap();

    _getRequireWildcardCache = function () {
      return cache;
    };

    return cache;
  }

  function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
      return obj;
    }

    var cache = _getRequireWildcardCache();

    if (cache && cache.has(obj)) {
      return cache.get(obj);
    }

    var newObj = {};

    if (obj != null) {
      var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;

      for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;

          if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }
    }

    newObj.default = obj;

    if (cache) {
      cache.set(obj, newObj);
    }

    return newObj;
  }

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function _objectWithoutProperties(source, excluded) {
    if (source == null) return {};

    var target = _objectWithoutPropertiesLoose(source, excluded);

    var key, i;

    if (Object.getOwnPropertySymbols) {
      var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

      for (i = 0; i < sourceSymbolKeys.length; i++) {
        key = sourceSymbolKeys[i];
        if (excluded.indexOf(key) >= 0) continue;
        if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
        target[key] = source[key];
      }
    }

    return target;
  }

  function _objectWithoutPropertiesLoose(source, excluded) {
    if (source == null) return {};
    var target = {};
    var sourceKeys = Object.keys(source);
    var key, i;

    for (i = 0; i < sourceKeys.length; i++) {
      key = sourceKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      target[key] = source[key];
    }

    return target;
  }

  const ChipGroupToolbarItem = exports.ChipGroupToolbarItem = _ref => {
    let {
      categoryName = '',
      children = null,
      className = '',
      isClosable = false,
      onClick = _e => undefined,
      closeBtnAriaLabel = 'Close chip group'
    } = _ref,
        props = _objectWithoutProperties(_ref, ["categoryName", "children", "className", "isClosable", "onClick", "closeBtnAriaLabel"]);

    if (React.Children.count(children)) {
      const renderChipGroup = (id, HeadingLevel) => {
        return React.createElement("ul", _extends({
          className: (0, _reactStyles.css)(_chipGroup2.default.chipGroup, _chipGroup2.default.modifiers.toolbar, className)
        }, props), React.createElement("li", null, React.createElement(HeadingLevel, {
          className: (0, _reactStyles.css)(_chipGroup2.default.chipGroupLabel),
          id: id
        }, categoryName), React.createElement("ul", {
          className: (0, _reactStyles.css)(_chipGroup2.default.chipGroup)
        }, children), isClosable && React.createElement("div", {
          className: "pf-c-chip-group__close"
        }, React.createElement(_ChipButton.ChipButton, {
          "aria-label": closeBtnAriaLabel,
          onClick: onClick,
          id: `remove_group_${id}`,
          "aria-labelledby": `remove_group_${id} ${id}`
        }, React.createElement(_timesIcon2.default, {
          "aria-hidden": "true"
        })))));
      };

      return React.createElement(_ChipGroup.ChipGroupContext.Consumer, null, HeadingLevel => {
        return React.createElement(_GenerateId2.default, null, randomId => renderChipGroup(randomId, HeadingLevel));
      });
    }

    return null;
  };

  ChipGroupToolbarItem.propTypes = {
    categoryName: _propTypes2.default.string,
    children: _propTypes2.default.node.isRequired,
    className: _propTypes2.default.string,
    isClosable: _propTypes2.default.bool,
    onClick: _propTypes2.default.func,
    closeBtnAriaLabel: _propTypes2.default.string
  };
});
//# sourceMappingURL=ChipGroupToolbarItem.js.map